function [dphis,initslope] = newton1d(N,phis,phirw,contparams,Hw,ev,diffpotential,R,exact,singtol,Rpenalty)
% Hessian and slope in search direction
if (exact)
  J = Hw'.*repmat(2*contparams(1)*diffpotential+...
		  6*contparams(2)*(phirw.^2),1,N);
  J = Hw*J;
  J = J+spdiags(ev-2*phis(N+1),0,N,N);
  J = [J -2*phis(1:N)];
  J = [J;-2*phis(1:N)' 0];
  dphis = -J\R;
else
  if isempty(singtol)
    singtol = 1e-8;
  end
  J = (Hw.^2)*(2*contparams(1)*diffpotential+...
	       6*contparams(2)*(phirw.^2));
  J = J+(ev-2*phis(N+1));
% descent direction if J(i,i)==0
  RN = R(1:N);
%  J(abs(J) < singtol*norm(RN)) = -sign(RN(abs(J) < singtol*norm(RN)));
  J = J*max(1,singtol*norm(RN)/norm(J));
  J(J == 0) = 1;
  J = abs(J);
% solve
  dphis = modJinv1d(J,-2*phis(1:N),-R);
end
initslope = Rpenalty'*dphis(1:N);
