function mainGPE1d
addpath('Hermite');
addpath('../common');
% Dirac constant
hbar = 1.054571628e-34;
%%% USER DEFINED PARAMETERS
% Number of Hermite functions
NH = 256; 
h = hbar;
m = 1.44e-25;
N = 1e7;
g = 1e-2;
omegax = 1;
% Scale of Hermite functions
beta = sqrt(omegax);
% x range (used only for the plot). The y range is equal to the x range 
% (but can be modified inside function plots).
% The z range is automatic.
xmin = -10;
xmax = 10;
% How much fine is the surface
M = 1001;
%%% END OF USER DEFINED PARAMETERS GOTO POTENTIAL
c = m/h;
d = h*c/m;
theta = 2*pi*sqrt(c)*h*g*(m+m)/(m*m);
% Number of Hermite functions
tic
[phis,mu,energy,counter] = ...
groundstate1d(h,d,c,N,theta,NH,beta,0,@potential);
toc
counter(1)
counter(2)
mu
energy
% Plots function
plots1d(M,xmin,xmax,c,phis,beta)
hold on
xx = linspace(xmin,xmax,1000)/sqrt(c);
figure
plot(xx,potential(xx))

function y = potential(x)
% potential V1
x0 = 0;
omegax = 1;
m = 1.44e-25;
y = m*(omegax^2*(x-x0).^2)/2+m*cos(4e5*x)*1e-8;  

%%% END OF USER DEFINED PARAMETERS

