function [energy,varargout] = energy2dsys(N,phis,phirw,contparams,ev,...
					  diffpotential,varargin)
% with 6 input arguments, energy and vector of chemical potentials
% with 7 input arguments, energy, exact penalty function and 
% the upper bound r for Lagrange multipliers
l = length(phis)-1;
[phirw2{1:l}] = deal(zeros(size(phirw{1})));
% precompute squares
for i = 1:l
  phirw2{i} = phirw{i}.^2;
end
nlp = zeros(l);
for i = 1:l
  nlp(i,i) = sum(sum(phirw2{i}.^2))/2;
  for j = i+1:l
    nlp(i,j) = sum(sum((phirw2{i}.*phirw2{j})));
    nlp(j,i) = nlp(i,j);
  end
end
energyi = zeros(l,1);
% energyi(i) 
for i = 1:l
  energyi(i) = norm(phis{i}.*sqrt(ev{i}/2))^2+...
    contparams{1}(i)*sum(sum(diffpotential{i}.*phirw2{i}))+...
    contparams{2}(i,i)*nlp(i,i);
end
energy = sum(energyi)+sum(sum(contparams{2}.*(nlp-diag(diag(nlp)))))/2;
if (nargin == 7)
  r = varargin{1};
  if (r == -1)
    r = max((energyi+sum(contparams{2}.*nlp,2))./N);
  end
  varargout{2} = r;
  varargout{1} = energy;
  for i = 1:l
    varargout{1} = varargout{1}+r*abs(N(i)-norm(phis{i})^2);
  end
end
if ((nargout == 2) & (nargin == 6))
  varargout{1} = (energyi+sum(contparams{2}.*nlp,2))./N;
end
  
