function [Hw,lambda,W] = init2drk(N,NH,h,d,c,beta,potential,m,omega) 
indx = 0;
indy = 0;
delta = sqrt(2);
% Gauss--Hermite quadrature nodes and (fourth root of) weights relative to the 
% weight w(x) = exp(-(delta*beta*x)^2).
ab = r_hermite(2*NH(1)-1);
[xw] = gauss(2*NH(1)-1,ab);
x = xw(:,1)/delta/beta(1);
%[dummy,idx] = sort(abs(x),'descend');
%x = x(idx);
wx = (xw(:,2)/delta/beta(1)).^0.25;
%wx = wx(idx);
Wx = spdiags(wx,0,2*NH(1)-1,2*NH(1)-1);
ab = r_hermite(2*NH(2)-1);
[yw] = gauss(2*NH(2)-1,ab);
y = yw(:,1)/delta/beta(2);
%[dummy,idy] = sort(abs(y),'descend');
%y = y(idy);
wy = (yw(:,2)/delta/beta(2)).^0.25;
%wy = wy(idy);
Wy = spdiags(wy,0,2*NH(2)-1,2*NH(2)-1);
[X,Y] = meshgrid(x,y);
% Hermite polynomials orthonormal with respect to the weight w(x/delta),
% times the weights
Hw{1} = hermatw(x,NH(1),beta(1),wx');
Hw{2} = hermatw(y,NH(2),beta(2),wy');
% Common eigenvalues relative to -d^2 / d x^2 + 1/2 (beta^2*x)^2
[xev,yev] = meshgrid(2*[0:NH(1)-1],2*[0:NH(2)-1]);
lambda = d*((1+xev)*beta(1)^2+(1+yev)*beta(2)^2);
lambda = lambda(:);
W = (feval(potential,X/sqrt(c),Y/sqrt(c),m,omega)/h-...
  d*((beta(1)^2*X).^2+(beta(2)^2*Y).^2)/2);
W = W.*(Wy*exp((beta(1)^2*X.^2+beta(2)^2*Y.^2)/2)*Wx).^2;
