function [phis,Hw,ev,diffpotential,contparams] = ...
      init2dsys(N,NH,h,d,c,beta,potential,m,omega) 
l = length(potential);
indx = zeros(l,1);
indy = zeros(l,1);
delta = sqrt(2);
% Gauss--Hermite quadrature nodes and (fourth root of) weights relative to the 
% weight w(x) = exp(-(delta*beta*x)^2).
ab = r_hermite(2*NH(1)-1);
[xw] = gauss(2*NH(1)-1,ab);
x = xw(:,1)/delta/beta(1);
%[dummy,idx] = sort(abs(x),'descend');
%x = x(idx);
wx = (xw(:,2)/delta/beta(1)).^0.25;
%wx = wx(idx);
Wx = spdiags(wx,0,2*NH(1)-1,2*NH(1)-1);
ab = r_hermite(2*NH(2)-1);
[yw] = gauss(2*NH(2)-1,ab);
y = yw(:,1)/delta/beta(2);
%[dummy,idy] = sort(abs(y),'descend');
%y = y(idy);
wy = (yw(:,2)/delta/beta(2)).^0.25;
%wy = wy(idy);
Wy = spdiags(wy,0,2*NH(2)-1,2*NH(2)-1);
[X,Y] = meshgrid(x,y);
% Hermite polynomials orthonormal with respect to the weight w(x/delta),
% times the weights
Hw{1} = hermatw(x,NH(1),beta(1),wx');
Hw{2} = hermatw(y,NH(2),beta(2),wy');
% Common eigenvalues relative to -d^2 / d x^2 + 1/2 (beta^2*x)^2
[xev,yev] = meshgrid(2*[0:NH(1)-1],2*[0:NH(2)-1]);
[phirw{1:l}] = deal(zeros(2*NH(2)-1,2*NH(1)-1));
[phis{1:l}] = deal(zeros(NH(2)*NH(1),1));
phis{l+1} = zeros(l,1);
[ev{1:l}] = deal(zeros(NH(2)*NH(1),1));
[diffpotential{1:l}] = deal(zeros(2*NH(2)-1,2*NH(1)-1));
contparams{1} = zeros(l,1);
for i = 1:l
  phirw{i} = Hw{2}(indy(i)+1,:)'*Hw{1}(indx(i)+1,:);
%  phis{i} = Hw{2}*(phirw{i}.*...
%		   (Wy*exp((beta(1)^2*X.^2+beta(2)^2*Y.^2)/2)*Wx).^2)*Hw{1}'
  phis{i}(indy+1,indx+1) = 1;
  phis{i} = sqrt(N(i))*phis{i}(:);
  phis{l+1}(i) = indx(i)+indy(i)+1;
  ev{i} = d(i)*((1+xev)*beta(1)^2+(1+yev)*beta(2)^2);
  ev{i} = ev{i}(:);
  diffpotential{i} = (feval(potential{i},X/sqrt(c),Y/sqrt(c),m(i),omega(i,:))/h-...
  d(i)*((beta(1)^2*X).^2+(beta(2)^2*Y).^2)/2);
  diffpotential{i} = diffpotential{i}.*...
      (Wy*exp((beta(1)^2*X.^2+beta(2)^2*Y.^2)/2)*Wx).^2;
  contparams{1}(i) = 1/(sum(sum(abs(diffpotential{i}).*phirw{i}.^2))+1);
end
